<template>
    <div class="todo-list-column">
        <h2>
            {{ todoList.title }}
        </h2>
        <div class="todos-column">
            <draggable 
                v-model="filteredTodos"
                group="todos"
                tag="ul"
                drag-class="task-drag-active"
                ghost-class="task-drag-ghost"
                @change="onReorder"
            >
                <div v-for="todo in filteredTodos" :key="todo.id" class="todo-item">
                    <TodoItem 
                        :todo="todo"
                        :onDelete="deleteTodo" 
                        :onClick="()=>{ onEdit(todo) }" 
                        >
                    </TodoItem>
                </div>
            </draggable>
        </div>
        <v-btn 
            v-show="showNewTodo != todoList.id" 
            @click="showNewTodo = todoList.id"
            >
            Add a card
        </v-btn>
        <CreateNewTodo 
            v-show="showNewTodo == todoList.id" 
            :listId="todoList.id"
            :onCreate="createNewTodo"
            :onCancel="()=>{ showNewTodo = 0 }"
        />
</div>
</template>

<script>

import TodoItem from '@/components/TodoItem.vue';
import CreateNewTodo from '@/components/CreateNewTodo.vue';
import draggable from 'vuedraggable'
import { calculateDragPosition } from '@/utils'
import { mapActions, mapGetters } from 'vuex';

export default {
    name: 'TodoList',
    props:{
        todoList:{
            required: true,
            type: Object,
        },
        onEdit:{
            required: true,
        }
    },
    components:{
        TodoItem,
        CreateNewTodo,
        draggable,
    },
    data: ()=>({
        showNewTodo: 0,
    }),
    computed:{
        ...mapGetters([
            'todos',
            'sortedTodos',
            'search'
        ]),
        filteredTodos:{
            get(){
                const sorted = this.sortedTodos.filter(t => {
                    return t.list == this.todoList.id &&
                        (
                            this.search == "" ||
                            t.title.toLowerCase().includes(this.search.toLowerCase()) ||
                            t.description.toLowerCase().includes(this.search.toLowerCase())
                        );
                });
                return sorted;
            },
            set(value){
                // ignore, using onReorder instead
            }
        },
    },
    methods:{
        ...mapActions([
            'addList',
            'addTodo',
            'deleteTodo',
            'updateTodo',
        ]),
        createNewTodo(newTodo){
            this.addTodo(newTodo);
        },
      
        onReorder(e){
            let item = e.added || e.moved; 
            if(!item) return;

            const todoObj = item.element;
            let position = this.getPosition(item, todoObj);
            const updates = {
                position, 
                list: this.todoList.id
            }
            this.updateTodo({ 
                todoId: todoObj.id, 
                updates 
            });
        },
        getPosition({ newIndex, oldIndex }, todo){
            let prev = newIndex > oldIndex ? this.todos[newIndex] : this.todos[newIndex - 1];
            let next = newIndex > oldIndex ? this.todos[newIndex + 1] : this.todos[newIndex];
            
            return calculateDragPosition(todo.position, prev, next);
        }
    }
}
</script>

<style lang="scss" scoped>
    .todo-list-column{
        padding-bottom: 50px;
        margin-bottom: 50px;
        background: grey;
    }
    .todos-column{
        border: 1px solid red;
        ul{
            padding: 25px 0;
            border: 1px solid blue;
        }
    }
    .task-drag-active{

    }
    .task-drag-ghost{

    }
</style>